diff -uNr -x CVS u-boot-suzaku/board/AtmarkTechno/suzaku/suzaku.c u-boot-suzaku-board_init-fix/board/AtmarkTechno/suzaku/suzaku.c
--- u-boot-suzaku/board/AtmarkTechno/suzaku/suzaku.c	2004-04-07 20:05:47.000000000 +0900
+++ u-boot-suzaku-board_init-fix/board/AtmarkTechno/suzaku/suzaku.c	2004-04-07 19:15:49.000000000 +0900
@@ -24,13 +24,6 @@
 
 #include <common.h>
 
-void board_init(void)
-{
-        serial_init();
-
-        main_loop();
-}
-
 void do_reset(void)
 {
 }
diff -uNr -x CVS u-boot-suzaku/lib_microblaze/board.c u-boot-suzaku-board_init-fix/lib_microblaze/board.c
--- u-boot-suzaku/lib_microblaze/board.c	2004-04-07 20:05:48.000000000 +0900
+++ u-boot-suzaku-board_init-fix/lib_microblaze/board.c	2004-04-07 19:16:30.000000000 +0900
@@ -26,6 +26,7 @@
 #include <command.h>
 #include <malloc.h>
 #include <version.h>
+#include <watchdog.h>
 
 const char version_string[] =
 	U_BOOT_VERSION" (" __DATE__ " - " __TIME__ ")";
@@ -69,6 +70,24 @@
 	NULL,
 };
 
+void board_init(void)
+{
+        init_fnc_t **init_fnc_ptr;
+
+        for (init_fnc_ptr = init_sequence; *init_fnc_ptr; ++init_fnc_ptr) {
+                WATCHDOG_RESET ();
+                if ((*init_fnc_ptr) () != 0) {
+                        hang ();
+                }
+        }
+
+        /* main_loop */
+        for (;;) {
+                WATCHDOG_RESET ();
+                main_loop ();
+        }
+}
+
 void hang (void)
 {
 	puts ("### ERROR ### Please RESET the board ###\n");
